/*	$Header: /usr/people/sam/fax/util/RCS/faxsubmit.c,v 1.12 93/03/31 14:59:05 sam Rel $
/*
 * Copyright (c) 1990, 1991, 1992, 1993 Sam Leffler
 * Copyright (c) 1991, 1992, 1993 Silicon Graphics, Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * Sam Leffler and Silicon Graphics may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of Sam Leffler and Silicon Graphics.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL SAM LEFFLER OR SILICON GRAPHICS BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */
#include <stdio.h>
#include <string.h>
#include <syslog.h>
#include <fcntl.h>
#include <sys/file.h>

#include "config.h"
#include "flock.h"

main(int argc, char** argv)
{
    FILE *qfile;
    int fifo, len;
    char *fname;
    char *appname = argv[0];
    char *modem;
    char buf[80];
    char fifoname[1024];

    openlog(appname, LOG_PID, LOG_FAX);
    if (argc != 2 && argc != 3) {
	syslog(LOG_ERR, "usage: %s filename [modem]; called with %d args",
	    appname, argc);
	exit(1);
    }
    fname = argv[1];
    qfile = fopen(fname, "a+");
    if (qfile) {
	flock(fileno(qfile), LOCK_EX);
	fprintf(qfile, "tts:0\n");
	fclose(qfile);
    } else {
	syslog(LOG_ERR, "open %s: %m", fname);
    }
    modem = (argc == 2 ? MODEM_ANY : argv[2]);
    if (strcmp(modem, MODEM_ANY) == 0)
	strcpy(fifoname, FAX_FIFO);
    else
	sprintf(fifoname, "%s.%.*s", FAX_FIFO,
	    sizeof (fifoname) - (sizeof (FAX_FIFO)+2), modem);
    fifo = open(fifoname, O_WRONLY|O_NDELAY);
    if (fifo < 0) {
	syslog(LOG_ERR, "%s: open: %m", fifoname);
	exit(2);
    }
    strcpy(buf+1, fname);
    buf[0] = 'S';
    len = strlen(buf);
    if (write(fifo, buf, len+1) != len+1) {
	syslog(LOG_ERR, "fifo write failed for send (%m)");
	exit(3);
    }
    (void) close(fifo);
    exit(0);
}
